format PE64 GUI 6.0
entry WinMain
include 'win64a.inc'
IMAGE_BASE	equ 0x400000
struct RectF
       x dd ?	  ;REAL = REAL4
       y dd ?
       awidth dd ?
       height dd ?
ends
struct GdiplusStartupInput
       GdiplusVersion		dd ?
       DebugEventCallback	dd ?
       SuppressBackgroundThread dd ?
       SuppressExternalCodecs	dd ?
ends
UnitWorld		equ	0
section '.code' code readable executable
proc WinMain
local msg:MSG
	frame
	invoke GdiplusStartup,gdiplusToken,gdiplusStartupInput,NULL
	xor ebx,ebx
	mov ecx,FileName
	invoke LoadCursorFromFile
	mov esi,IMAGE_BASE
	mov edi,ClassName
	push rax    ;hIconSm
	push rdi    ;lpszClassName
	push rbx    ;lpszMenuName
	push COLOR_WINDOWTEXT;hbrBackground=black
	push 10003h ;hCursor
	push rax    ;hIcon  
	push rsi    ;hInstance
	push rbx    ;cbClsExtra & cbWndExtra
	push WndSDI
	push sizeof.WNDCLASSEX;cbSize & style
	invoke RegisterClassEx,esp;addr WNDCLASSEX
    push rbx
    push rsi	;rsi=400000h
    shl esi,9	;rsi=CW_USEDEFAULT
    push rbx
    push rbx
    push 90
    push 270
    push rsi
    push rsi
    sub rsp,20h
    xor ecx,ecx
    invoke CreateWindowEx,,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
    lea edi,[msg]
@@: xor r9,r9
    xor r8,r8
    xor edx,edx
    invoke GetMessage,edi
    invoke DispatchMessage,edi
    jmp @b
    endf
endp
;----------------------------------------
proc WndSDI hwnd,uMsg,wParam,lParam
local Ps:PAINTSTRUCT
local hdc:QWORD
local graphics:QWORD

	mov [hwnd],rcx
	frame
	cmp edx,WM_DESTROY
	je wmDESTROY
	cmp edx,WM_CREATE
	je wmCREATE
	cmp edx,WM_PAINT
	je wmPAINT
	leave
	jmp [NtdllDefWindowProc]
wmDESTROY:invoke DeleteObject,[Hcompatibledc]
	invoke DestroyWindow, [hwnd]
	invoke GdiplusShutdown,[gdiplusToken]
	invoke DeleteObject,[Hfont]
	xor ecx,ecx
	invoke RtlExitUserProcess

wmCREATE:mov ecx,logfont
	invoke CreateFontIndirect
	mov [Hfont],rax
	mov edx,WM_SETFONT
	xor r9,r9;FALSE
	invoke SendMessage,[hwnd],,rax
;---------- prepare all can be possible for drawing here (WM_PAINT is faster as this)
	xor ecx,ecx;NULL
	xor edx,edx;LANG_NEUTRAL
	mov r8d,nativeFormat
	invoke GdipCreateStringFormat
	mov ecx,0FF00C832h
	mov edx,nativebrush
	invoke GdipCreateSolidFill
	xor eax,eax
	jmp wmBYE
wmPAINT:lea edx,[Ps]
	invoke BeginPaint	 
	mov [hdc],rax
	lea edx,[graphics]
	invoke GdipCreateFromHDC,[hdc]
	lea edx,[graphics]
	invoke GdipCreateFromHWND,[hwnd]
	mov edx,logfont
	mov r8d,gpfont
	invoke GdipCreateFontFromLogfont,[hdc]
	mov edx,wphrase
	or r8,-1
	invoke GdipDrawString,[graphics],,,[gpfont],RectText,[nativeFormat],[nativebrush]
	invoke GdipDeleteFont,[gpfont]
	lea edx,[Ps]
	invoke EndPaint,[hwnd]
wmBYE:	endf
	leave
	retn
endp
;-----------------------------------------
section '.data' data readable writeable
ClassName db "GDI+  ",0
FileName  db "br_Rabbit3.cur",0
gdiplusStartupInput GdiplusStartupInput 1,NULL,FALSE,FALSE
nativeFormat dq 0
Hcompatibledc dq 0
wphrase du "hello, World!",0
nativebrush dq 0
gpfont dq 0
Hfont dq ?
logfont LOGFONT 36,12,0,0,400,0,0,0,0,0,0,0,DEFAULT_PITCH or FF_SCRIPT,"Times New Roman"
RectText RectF	0.0,0.0,270.0,90.0
gdiplusToken dq ?
;-----------------------------------------------
section '.idata' import data readable writeable
  library ntdll,'ntdll.dll',\
	  user,'USER32.DLL',\
	  gdiplus,'gdiplus.dll',\
	  gdi,'GDI32.DLL'

  import gdiplus,\
	 GdiplusShutdown,'GdiplusShutdown',\
	 GdipCreateStringFormat,'GdipCreateStringFormat',\
	 GdipCreateFromHDC,'GdipCreateFromHDC',\
	 GdipCreateFromHWND,'GdipCreateFromHWND',\
	 GdipCreateFontFromLogfont,'GdipCreateFontFromLogfontA',\
	 GdipDrawString,'GdipDrawString',\
	 GdipCreateSolidFill,'GdipCreateSolidFill',\
	 GdipDeleteFont,'GdipDeleteFont',\
	 GdiplusStartup,'GdiplusStartup'
  import user,\
	 LoadCursorFromFile,'LoadCursorFromFileA',\
	 RegisterClassEx,'RegisterClassExA',\
	 GetMessage,'GetMessageA',\
	 DispatchMessage,'DispatchMessageA',\
	 DestroyWindow,'DestroyWindow',\
	 SendMessage,'SendMessageA',\
	 BeginPaint,'BeginPaint',\
	 EndPaint,'EndPaint',\
	 CreateWindowEx,'CreateWindowExA'
  import gdi,\
	 DeleteObject,'DeleteObject',\
	 CreateFontIndirect,'CreateFontIndirectA'
  import ntdll,\
	 NtdllDefWindowProc,'NtdllDefWindowProc_A',\
	 RtlExitUserProcess,'RtlExitUserProcess'